//+------------------------------------------------------------------+
//|                                            double smooth ema.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int    emaPeriod       = 20;
extern int    emaPrice        = PRICE_CLOSE;
extern double PctFilter       = 3.5;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double emaBuffer[];
double emaBufferDa[];
double emaBufferDb[];
double wrkBuffer[];
double trend[];
double alpha;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,emaBuffer);
   SetIndexBuffer(1,emaBufferDa);
   SetIndexBuffer(2,emaBufferDb);
   SetIndexBuffer(3,wrkBuffer);
   SetIndexBuffer(4,trend);
   emaPeriod = MathMax(emaPeriod,1);
   alpha     = 2.0 /(1.0+MathSqrt(emaPeriod));
   
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//
//
//

double work[][2];
#define _change 0
#define _achang 1

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
   //
   //
   //
   //
   //
            
   if (trend[limit]==-1) CleanPoint(limit,emaBufferDa,emaBufferDa);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,emaPrice,i);
         if (i==Bars-1)
         {
            emaBuffer[i] = price;
            wrkBuffer[i] = price;
            continue;
         }
         
         wrkBuffer[i]   = wrkBuffer[i+1] + alpha*(price       -wrkBuffer[i+1]);
         emaBuffer[i]   = emaBuffer[i+1] + alpha*(wrkBuffer[i]-emaBuffer[i+1]);
         
         //
         //
         //
         //
         //
         
         if (PctFilter>0)
         {
            work[r][_change] = MathAbs(emaBuffer[i]-emaBuffer[i+1]);
            work[r][_achang] = work[r][_change];
            for (int k=1; k<emaPeriod ; k++) work[r][_achang] += work[r-k][_change];
                                             work[r][_achang] /= 1.0*emaPeriod ;
    
            double stddev = 0; for (k=0; k<emaPeriod ; k++) stddev += MathPow(work[r-k][_change]-work[r-k][_achang],2);
                   stddev = MathSqrt(stddev/emaPeriod); 
            double filter = PctFilter * stddev;
            if( MathAbs(emaBuffer[i]-emaBuffer[i+1]) < filter) emaBuffer[i]=emaBuffer[i+1];
         }
         
         //
         //
         //
         //
         //
         
         emaBufferDa[i] = EMPTY_VALUE;
         emaBufferDb[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
            if (emaBuffer[i]>emaBuffer[i+1]) trend[i] =  1;
            if (emaBuffer[i]<emaBuffer[i+1]) trend[i] = -1;
            if (trend[i]==-1) PlotPoint(i,emaBufferDa,emaBufferDb,emaBuffer);
         
         }
   
         //
         //
         //
         //
         //
      
         if (alertsOn)
         {
           if (alertsOnCurrent)
                int whichBar = 0;
           else     whichBar = 1;
         
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("Buy");
           else  doAlert("Sell");       
   }
return(0);
}
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Double smoothed ema ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Double smoothed ema "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

